
' Accessability
' Pirate Kart 2012
' Kristopher Windsor

#include once "fbgfx.bi"

const sx = 800, sy = 600
const dot_max = 10, dot_size = 32, player_size = 50

screenres sx, sy, 32

type xyv
  dim as double x, y, xv, yv
end type

dim as integer dot_total = dot_max, mx, my, mb
dim as xyv player, dots(1 to dot_max)
dim as fb.image ptr background = imagecreate(sx, sy)

randomize()

with player
  .x = sx / 2
  .y = sy / 2
end with
for i as integer = 1 to dot_max
  with dots(i)
    .x = sx * rnd()
    .y = sy * rnd()
  end with
next i

bload("wheelchair.bmp", background)

do
  '~ Controls ~
  'Down: p+z
  'Right: ~+p
  'Up: left mouse
  'Left: &+g
  getmouse(mx, my,, mb)
  with player
    if multikey(fb.SC_P) and multikey(fb.SC_Z) then .yv += 1
    if multikey(fb.SC_TAB) and multikey(fb.SC_P) then .xv += 1
    if mb and 1 then .yv -= 1
    if multikey(fb.SC_7) and multikey(fb.SC_G) then .xv -= 1
    .xv *= .9
    .yv *= .9
    .x += .xv
    .y += .yv
    if .x < 0 then .x = 0
    if .x > sx then .x = sx
    if .y < 0 then .y = 0
    if .y > sy then .y = sy
  end with
  
  'crash
  for i as integer = 1 to dot_total
    with dots(i)
      if (.x - player.x) ^ 2 + (.y - player.y) ^ 2 < (dot_size + player_size) ^ 2 then
        dot_total -= 1
        for j as integer = i to dot_total
          dots(j) = dots(j + 1)
        next j
        i -= 1
        if i = dot_total then exit for
      end if
    end with
  next i
  
  'display
  screenlock()
  put (0, 0), background, alpha, 100
  if dot_total = 0 then
    draw string (sx \ 2 - 8, sy * .4), "WIN!", &HFF000000
  end if
  for i as integer = 1 to dot_total
    with dots(i)
      circle (.x, .y), dot_size, &HFF8888FF,,, 1, F
      draw string (.x, .y), "" & i
    end with
  next i
  with player
    circle (.x, .y), player_size, &HFFFF2222,,, 1, F
  end with
  screenunlock()
  
  sleep(15, 1)
loop until inkey = chr(27)
